<template>
  <q-page class="row q-pa-sm">
    <form-user
      ref="avatar"
      v-model="userData.user"
      class="col q-pa-sm"
      :vuelidate="$v.userData.user"
      title="Dados Pessoais"
      :only-pwd="false"
      :is-user="true"
      @save="save"
    />

    <q-list
      class="col rounded-borders q-ma-sm"
      bordered
    >
      <q-expansion-item
        ref="password"
        group="item"
        icon="las la-fingerprint"
        label="Alterar Senha"
        header-class="text-subtitle1 text-bold text-grey-9"
      >
        <form-user
          v-model="userData.user"
          :vuelidate="$v.userData.user"
          :only-pwd="true"
          :is-user="true"
        />
      </q-expansion-item>

      <q-separator />

      <q-expansion-item
        ref="address"
        group="item"
        icon="las la-home"
        label="Atualizar Endereço"
        header-class="text-subtitle1 text-bold text-grey-9"
      >
        <form-address
          v-model="userData.address"
          :vuelidate="$v.userData.address"
        />
      </q-expansion-item>
    </q-list>
  </q-page>
</template>

<script>
import { required, minLength, maxLength, minValue, email, sameAs } from 'vuelidate/lib/validators'
import FormUser from '../../components/header/form-user'
import FormAddress from '../../components/header/form-address'
import { formatToDate, parseToDate } from 'brazilian-values'
import { uid } from 'quasar'
import _ from 'lodash'

const fullName = name => _.size(name) > 2 ? _(name).words().size() > 1 : true
const factoryUser = JSON.stringify({
  name: '',
  documentNumber: '',
  bornAt: '',
  phone: '',
  email: '',
  password: '',
  repeatPassword: '',
  avatar: ''
})
const factoryAddress = JSON.stringify({
  street: '',
  streetNumber: '',
  complementary: '',
  neighborhood: '',
  zipcode: '',
  city: '',
  state: ''
})

export default {
  name: 'PageProfile',
  components: {
    FormUser,
    FormAddress
  },
  asyncData: {
    userDataDefault: { user: JSON.parse(factoryUser), address: JSON.parse(factoryAddress) },
    async userData () {
      if (!this.$store.state.session.user.id) {
        this.$router.push(window.sessionStorage.urlGoTo || '/')

        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: `/Usuarios/${this.$store.state.session.user.id}`,
          params: { filter: { fields: ['name', 'documentNumber', 'bornAt', 'phone', 'email', 'avatar', 'address'] } }
        }

        const { address, ...user } = await this.$axios(axiosConfig).then(R => R.data)

        user.bornAt = formatToDate(new Date(user.bornAt))
        user.phone = user.phone.ddd + user.phone.number
        user.repeatPassword = ''
        user.password = ''

        return { user, address }
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
      }

      return undefined
    }
  },
  validations: {
    userData: {
      user: {
        name: {
          required,
          minLength: minLength(3),
          maxLength: maxLength(60),
          fullName
        },
        documentNumber: {
          required,
          minLength: minLength(11)
        },
        bornAt: {
          required
        },
        phone: {
          required,
          minLength: minLength(10),
          maxLength: maxLength(11)
        },
        email: {
          required,
          email
        },
        password: {
          minLength: minLength(8),
          maxLength: maxLength(24)
        },
        repeatPassword: {
          sameAsPassword: sameAs('password')
        }
      },
      address: {
        street: {
          required,
          minLength: minLength(1),
          maxLength: maxLength(100)
        },
        streetNumber: {
          required,
          minValue: minValue(1)
        },
        complementary: {
          maxLength: maxLength(100)
        },
        neighborhood: {
          required,
          minLength: minLength(3),
          maxLength: maxLength(100)
        },
        zipcode: {
          required,
          minLength: minLength(8)
        },
        city: {
          required,
          minLength: minLength(3),
          maxLength: maxLength(100)
        },
        state: {
          required,
          minLength: minLength(2),
          maxLength: maxLength(2)
        }
      }
    }
  },
  methods: {
    async save () {
      this.$v.userData.$touch()

      if (this.$v.userData.$error) {
        if (this.$v.userData.user.password.$error || this.$v.userData.user.repeatPassword.$error) {
          this.$refs.password.show()
        }

        if (this.$v.userData.address.$error) {
          this.$refs.address.show()
        }

        return undefined
      }

      this.$q.loading.show()

      try {
        const user = JSON.parse(JSON.stringify(_.assign(this.userData.user, { address: this.userData.address })))

        user.bornAt = parseToDate(user.bornAt)
        user.avatar = await this.upload(user.avatar, this.$refs.avatar.$refs.takeScreenshot.generateDataUrl() || null)
        user.phone = { ddd: user.phone.substring(0, 2), number: user.phone.substring(2) }

        if (!user.password) {
          delete user.password
          delete user.repeatPassword
        }

        if (!user.address.complementary) {
          delete user.address.complementary
        }

        const axiosConfig = {
          method: 'PATCH',
          url: `/Usuarios/${this.$store.state.session.user.id}`,
          data: user
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Perfil atualizado com sucesso', '/auth/login')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
      }
    },
    async upload (avatar, base64) {
      if (!base64) {
        this.delete(avatar)

        return null
      }

      const file = await fetch(base64).then(R => R.blob())
      const fileName = avatar || uid() + '.png'

      try {
        const axiosConfig = {
          method: 'POST',
          url: '/Storages/usuarios/upload',
          headers: { 'Content-Type': 'multipart/form-data' },
          data: new FormData()
        }

        axiosConfig.data.append('file', file, fileName)

        await this.$axios(axiosConfig)

        return fileName
      } catch (err) {
        this.axiosCatch(err)
      }
    },
    async delete (file) {
      try {
        const axiosConfig = {
          method: 'DELETE',
          url: `/Storages/usuarios/files/${file}`
        }

        await this.$axios(axiosConfig)
      } catch (err) {
        this.axiosCatch(err)
      }
    }
  }
}
</script>
